#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "sgl+.h"

#define tmax 500
#define r    0.02
#define Lx   640
#define Ly   480
#define L    256  
#define LL   (L*L)
#define FILENAME0 "dataH%.4d"

int main(int argc, char *argv[]){

  int i,j,ii,step,t,int_temp;
  static int number;
  int imax,imin,jmax,jmin;
  int imax2,imin2;

  int blue,red;
  char string1[10];
  char string2[128];
  char string3[10];

  char string5[128];
  char string6[128];
  char string7[128];
  char string8[128];
  char string9[128];
  float Phi[Lx][Ly];
  int intPhi[L][L];
  char filename[32];

  FILE        *fp01;

  sgl_winsize(Lx,Ly);
  sgl_init();
  blue = sgl_colordef("blue");
  red  = sgl_colordef("red");
  /* sgl_color(SGL_WHITE); */
  sgl_color(SGL_BLACK); 
  sgl_color_background(SGL_BLACK);

/*=====================================================================*/
  /*


                         |
                         | 480 (
                         |
                         |
                         ------------------
                                640
                           64 - 512 - 64 

  */
/*=====================================================================*/

/*-----------------------------------------------------------------*/
/*                             Title                               */
/*-----------------------------------------------------------------*/

  for(j=0;j<Ly;j++){for(i=0;i<Lx;i++){ Phi[i][j]=2; }}
  sgl_2D_scalar_field( Phi );
  sgl_color(SGL_WHITE);
  sprintf(string5,"             Phase Separation       ");
  sprintf(string6,"                          of              ");
  sprintf(string7,"          Binary Fluid Mixture     ");
  sprintf(string8,"          with Same Viscosities     ");
  sprintf(string9,"Takashi Taniguchi and Masao Doi");
  // red  = sgl_colordef("red");
  sgl_text2(0.1,0.7,string5,'A');
  sgl_text2(0.1,0.6,string6,'A');
  sgl_text2(0.1,0.5,string7,'A');
  sgl_text2(0.1,0.4,string8,'A');
  sgl_text2(0.1,0.2,string9,'A');

  sgl_display();
  sgl_window2xwd();

  //for(i=0;i<50;i++){sgl_window2xwd();}
  //getchar();
  //------[ Black ]-------
      for(j=0;j<Ly;j++){for(i=0;i<Lx;i++){ Phi[i][j]=2; }}
  sgl_2D_scalar_field( Phi );
  sgl_display();

  for(j=0;j<Ly;j++){for(i=0;i<Lx;i++){ Phi[i][j]=2; }}
  sgl_2D_scalar_field( Phi );
  sgl_color(SGL_WHITE);
  sprintf(string5,"               Droplet Phase         ");
  sgl_text2(0.1,0.5,string5,'A');


  sgl_display();
  sgl_window2xwd();

  /*
    for(i=0;i<50;i++){sgl_window2xwd();}
    getchar();
  */

/*-----------------------------------------------------------------*/
/*
  for(j=0;j<Ly;j++){for(i=0;i<Lx;i++){ Phi[i][j]=2; }}
  sgl_2D_scalar_field( Phi );
  sgl_color(SGL_WHITE);
  sprintf(string5," Viscoelastic Phase Separation");
  sprintf(string6,"Takashi Taniguchi and Masao Doi");
  // red  = sgl_colordef("red");
  sgl_text2(0.1,0.6,string5,'A');
  sgl_text2(0.1,0.4,string6,'A');

  sgl_display();
  sgl_window2xwd();

*/

/*-----------------------------------------------------------------*/
/*
  for(j=0;j<Ly;j++){for(i=0;i<Lx;i++){ Phi[i][j]=2; }}
  sgl_2D_scalar_field( Phi );
  sgl_color(SGL_WHITE);
  sprintf(string5,"Two Fluid Model");
  sgl_text2(0.3,0.5,string5,'A');

  sgl_display();
  sgl_window2xwd();
  //getchar();
  */
/*=====================================================================*/

  imin=(Lx-256)/2;        imax=(Lx+256)/2;
  jmin=(Ly-256)/2;        jmax=(Ly+256)/2;

  step=1;number=1;
  for(t=1;t<=tmax;t++){

  /*-----------------------------------------------------------------*/
  /*                        READ of DATA                             */
  /*-----------------------------------------------------------------*/

  sprintf(filename,FILENAME0,number++);
  printf("time=%d\n",t);

  fp01 = fopen(filename,"r");
  for( ii = 0; ii < LL; ii++ ){ i = ii/L; j = ii-i*L;
  fscanf( fp01, " %d", &int_temp );
  intPhi[i][j]=int_temp;
  }
  fclose(fp01);    

  /*-----------------------------------------------------------------*/
  /* Background Color : Black                                        */

  for(j=0;j<Ly;j++){for(i=0;i<Lx;i++){ Phi[i][j]=2; }}

  /*-----------------------------------------------------------------*/

  for(j=jmin;j<jmax;j++){
    for(i=imin;i<imax;i++){
      // Phi[i][j] = (double)intPhi[i-imin][j-jmin]/256.0;
      Phi[i][j] = (double)intPhi[i-imin][j-jmin]/280.0;
    }
  }

  for(j=0;j<64;j++){
    for(i=imin;i<imax;i++){
      Phi[i][jmax+j]= Phi[i][jmin+j];
      Phi[i][jmin+j-64]= Phi[i][jmax+j-64];
    }
  }

  for(j=jmin-64;j<jmax+64;j++){
    for(i=0;i<64;i++){
      Phi[imax+i][j] = Phi[imin+i][j];
      Phi[imin+i-64][j] = Phi[imax+i-64][j];
    }
  }

  /*-----------------------------------------------------------------*/
  /* boundary */

  j=jmin-1;for(i=imin-64;i<imax+64;i++){ Phi[i][j] = 1.0;}
  j=jmax;  for(i=imin-64;i<imax+64;i++){ Phi[i][j] = 1.0;}
  i=imin-1;for(j=jmin-64;j<jmax+64;j++){ Phi[i][j] = 1.0;}
  i=imax;  for(j=jmin-64;j<jmax+64;j++){ Phi[i][j] = 1.0;}

  /* scale bar */
  imin2=imax+64+8;
  imax2=imin2+16;
  for(j=jmin;j<jmax;j++){
    for(i=imin2;i<imax2;i++){
      Phi[i][j] = (double)(256-j+jmin)/256;
    }
  }
  /*-----------------------------------------------------------------*/
  /*-----------------------------------------------------------------*/
  sgl_2D_scalar_field( Phi );
  /*-----------------------------------------------------------------*/
  sprintf(string3,"Time");
  sprintf(string1,"%5.d",step );
  // red  = sgl_colordef("red");
  sgl_color(SGL_WHITE);
  sgl_text2(0.05,0.85,string3,'A');
  sgl_text2(0.05,0.75,string1,'A');
  /*-----------------------------------------------------------------*/

  sgl_display();
  if( step%1 == 0 ){ 
    /* sgl_window2ppm(); */
    sgl_window2xwd();
  }
  step++;
}
//i=getchar();
}







