#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "sgl+.h"

#define L   480

int main(int argc, char *argv[])
{
	float x0 = 0.5, y0 = 0.5;
	float inv_eta = 1.0/0.25;
	int imax = 50;
  sgl_winsize(L,L);
  sgl_init();
	float y1 = 0.1;
	float y2 = 0.9;
	float Ly = y2-y1;
	float dy = Ly/imax;

	//-------------------------------------------
	// default
	//-------------------------------------------
	sgl_line(0.0, y1,  1.0,  y1);
	sgl_line(0.0, y2,  1.0,  y2);
	for( int i=0; i<=imax; i++ ){
		float y = y1 + dy*i;
		float vx = 0.5*( Ly*Ly*0.25 - (y-y0)*(y-y0) );
		float vy=0.0;
		sgl_arrow( x0, y, vx, vy );
	}
	sgl_display();
	getchar();

	//-------------------------------------------
	// size 
	//-------------------------------------------
	sgl_line(0.0, y1,  1.0,  y1);
	sgl_line(0.0, y2,  1.0,  y2);
	for( int i=0; i<=imax; i+=5 ){
		float y = y1 + dy*i;
		float vx = 0.5*inv_eta*( Ly*Ly*0.25 - (y-y0)*(y-y0) );
		float vy=0.0;
		sgl_arrow( x0, y, vx, vy, 0.4 );
	}
	sgl_display();
	getchar();


	//-------------------------------------------
	// size 
	//-------------------------------------------
	sgl_line(0.0, y1,  1.0,  y1);
	sgl_line(0.0, y2,  1.0,  y2);
	for( int i=0; i<=imax; i++ ){
		double y = y1 + dy*i;
		double vx = 0.5*inv_eta*( (y1-y0)*(y1-y0) - (y-y0)*(y-y0) );
		double vy = 0.0;
		sgl_arrow( x0, y, vx, vy, 0.01, 1 );
	}
	sgl_display();
	getchar();

}
